% **************************************************************************************************
%   Filename:       serialCallback.m
%   Revised:        $Date: 2011-07-23 $
%   Revision:       $Revision:   $
% 
%   Description:    Serial port callback function.
% 
% 
%   Copyright 2009-2010 Texas Instruments Incorporated. All rights reserved.
% 
%   IMPORTANT: Your use of this Software is limited to those specific rights
%   granted under the terms of a software license agreement between the user
%   who downloaded the software, his/her employer (which must be your employer)
%   and Texas Instruments Incorporated (the "License").  You may not use this
%   Software unless you agree to abide by the terms of the License. The License
%   limits your use, and you acknowledge, that the Software may not be modified,
%   copied or distributed unless embedded on a Texas Instruments microcontroller
%   or used solely and exclusively in conjunction with a Texas Instruments radio
%   frequency transceiver, which is integrated into your product.  Other than for
%   the foregoing purpose, you may not use, reproduce, copy, prepare derivative
%   works of, modify, distribute, perform, display or sell this Software and/or
%   its documentation for any purpose.
% 
%   YOU FURTHER ACKNOWLEDGE AND AGREE THAT THE SOFTWARE AND DOCUMENTATION ARE
%   PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED,
%   INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, TITLE,
%   NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL
%   TEXAS INSTRUMENTS OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER CONTRACT,
%   NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR OTHER
%   LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
%   INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE
%   OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT
%   OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
%   (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
% 
%   Should you have any questions regarding your right to use this Software,
%   contact Texas Instruments Incorporated at www.TI.com.
% **************************************************************************************************

function serialCallback(obj, event, handles)
% Executes when the device is started and data has been received. This
% function is also responsible for parsing the recieved data.
datastr = fgetl(obj);
% Parse datastr and send data to datahandler
% Example data string: 
% 1 01C6 01C4 0000 4 019C 019B 0000 0 024C 024B 0000 2 01DF 01DF 0000 3 0152 0152 0015
if( length(datastr) == 84)   % Simple error handling, discard string if wrong length
    buttonOrder = [1 4 0 2 3];
    data = cell(length(buttonOrder),1);
    for n = 1:length(buttonOrder)
        startIndex = 3 + (n-1)*17;
        data{buttonOrder(n)+1} = [hex2dec(datastr(startIndex:(startIndex+3)));...
                                  hex2dec(datastr((startIndex+5):(startIndex+8)));...
                                  hex2dec(datastr((startIndex+10):(startIndex+13)))];
    end
    handles.dh.newDataHandler(obj, data, handles);
end
end
